package com.company.kekw.app;

import com.company.kekw.entity.Project;
import com.company.kekw.entity.User;
import io.jmix.core.DataManager;
import io.jmix.core.querycondition.PropertyCondition;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.UUID;

@Component
public class NewBean {
    private final DataManager dataManager;

    public NewBean(DataManager dataManager) {
        this.dataManager = dataManager;
    }

    public void newMethod() {
        dataManager.load(Project.class);
    }

    Project loadById (UUID projectId) {
        return dataManager.load(Project.class).id(projectId).one();
    }

    List<User> loadByCondition() {
        return dataManager.load(User.class)
                .condition(PropertyCondition.contains("email", "@company.com"))
                .list();
    }
}