package com.company.kekw.view.projectstats;

import com.company.kekw.app.ProjectStatsService;
import com.company.kekw.entity.ProjectStats;
import com.company.kekw.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.core.LoadContext;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Collection;
import java.util.List;

@Route(value = "projectStatses", layout = MainView.class)
@ViewController("ProjectStats.list")
@ViewDescriptor("project-stats-list-view.xml")
@LookupComponent("projectStatsesDataGrid")
@DialogMode(width = "50em")
public class ProjectStatsListView extends StandardListView<ProjectStats> {

    @Autowired
    private ProjectStatsService projectStatsService;

    @Install(to = "projectStatsesDl", target = Target.DATA_LOADER)
    protected List<ProjectStats> projectStatsesDlLoadDelegate(LoadContext<ProjectStats> loadContext) {
        return projectStatsService.fetchProjectStatistics();
    }

    @Install(to = "projectStatsesDataGrid.remove", subject = "delegate")
    private void projectStatsesDataGridRemoveDelegate(final Collection<ProjectStats> collection) {
        for (ProjectStats entity : collection) {
            // Here you can remove entities from an external storage
        }
    }
}
